Index: unk/gsdl/perllib/textcat/uk-koi8_r.lm
===================================================================
--- /trunk/gsdl/perllib/textcat/uk-koi8_r.lm	(revision 1900)
+++ 	(revision )
@@ -1,400 +1,0 @@
-_	 21726
-Ï	 4832
-Á	 4080
-É	 3253
-Š	 2775
-Î	 2747
-×	 2642
-Ô	 2481
-Å	 2373
-Ò	 2066
-Ë	 1929
-Ä	 1806
-Ó	 1797
-Ì	 1760
-Õ	 1605
-Ð	 1347
-Í	 1345
-Ñ	 1061
-Ú	 1060
-Á_	 971
-Ï_	 965
-É_	 916
-_×	 902
-Â	 881
-_Ð	 869
-Å_	 847
-Ø	 843
-Š_	 810
-Ç	 760
-_Î	 696
-.	 676
-Þ	 654
-Ê	 647
-_Ó	 623
-"	 621
-_Ú	 606
-ÎÁ	 582
-_Ä	 565
-Ö	 543
-_Ô	 514
-ËÁ	 480
-._	 476
-ÔÉ	 464
-Ï×	 459
-×Š	 457
-Õ_	 457
-×_	 451
-À	 450
-Ñ_	 449
-_Ë	 443
-È	 438
-ÒÏ	 431
-Û	 428
-_Í	 419
-ÎÅ	 418
-ÐÏ	 414
-ÓÔ	 413
-€	 410
-ÔÏ	 400
-ÇÏ	 396
-Ø_	 394
-ÔØ	 377
-ÌÉ	 375
-ËÏ	 373
-ÒÁ	 358
-ÎÏ	 356
-Ê_	 354
-á	 354
-_Â	 350
-ÔÁ	 346
-,	 343
-ÏÄ	 341
-ÉÔ	 340
-ÏÌ	 336
-ÏÇ	 333
-×Á	 331
-Ã	 328
-Á×	 326
-,_	 323
-ÒÉ	 322
-ÄÏ	 321
-ÌÏ	 319
-ŠÄ	 318
-ÎÉ	 317
-÷	 314
-_ÐÏ	 314
-î	 312
-×É	 310
-ÏÒ	 310
-ÅÒ	 305
-ï	 295
-ÏÍ	 295
-ÎŠ	 294
-_ÎÁ	 289
-_ÎÅ	 288
-×Ï	 288
-Ý	 287
-ÅÎ	 282
-ÁÌ	 282
-ÎÁ_	 280
-ÚÁ	 274
-ô	 273
-ËÉ	 268
-_Š	 268
-§	 267
-ÐÒ	 266
-"_	 264
-ÏÇÏ	 254
-ÓÑ	 252
-ÁÔ	 252
-_"	 251
-ÔØ_	 251
-ÎÅ_	 249
-Í_	 248
-ð	 246
-ÔÉ_	 245
-I	 245
-ÉÊ	 244
-_Ò	 241
-€_	 239
-_ÄÏ	 239
-ÄÁ	 235
-ÏÂ	 235
-é	 233
-_Ñ	 232
-_Š_	 228
-ÖÅ	 228
-ÁÎ	 228
-Ë_	 226
-ÉÎ	 224
-_ÐÒ	 221
-ÍÏ	 219
-_ÚÁ	 218
-ŠÎ	 216
-Á€	 215
-ÍÁ	 214
-ÌÁ	 213
-_×Š	 210
-ÄÉ	 209
-_Ç	 207
-À_	 206
-ÒÅ	 206
-ÇÏ_	 204
-É×	 203
-_Ý	 203
-Ú_	 202
-ÝÏ	 201
-ÌŠ	 200
-ò	 199
-ÏÇÏ_	 199
-ó	 197
-ÓÑ_	 196
-ÉÓ	 193
-ÏÎ	 193
-_ÎÅ_	 190
-_ð	 190
-ŠÌ	 188
-ÏÓ	 187
-_Ï	 186
-ÔÅ	 186
-ÞÉ	 185
-ÁÒ	 184
-ÉÊ_	 184
-_÷	 176
-_×_	 174
-_Þ	 174
-ÑË	 173
-ÌØ	 173
-ë	 173
-ÁÓ	 170
-_ÝÏ	 169
-ÍÕ	 168
-ÂÕ	 167
-ñ	 166
-ÉÌ	 166
-ÉË	 163
-å	 163
-ÒŠ	 163
-ä	 163
-ú	 162
-ÝÏ_	 161
-ÔÒ	 160
-ÎŠ_	 160
-Š×	 160
-ÖÅ_	 159
-×ŠÄ	 159
-_Ì	 158
-ÔŠ	 155
-_×É	 155
-*	 154
-ÄÎ	 153
-ÁÍ	 153
-_*	 152
-Á€_	 152
-ÌÉ_	 152
-ØË	 152
-_ËÏ	 151
-È_	 151
-ËÕ	 151
-*_	 151
-ÄÅ	 151
-_*_	 150
-í	 149
-_Ú_	 149
-_ÑË	 148
-_Á	 147
-ÄŠ	 147
-ÄÕ	 146
-ÁÖ	 145
-_ÎÁ_	 144
-ÁÔÉ	 144
-ËÁ_	 143
-ÐÉ	 142
-_ÓÔ	 141
-ÓØ	 141
-ÌÑ	 140
-Î_	 139
-ÌÅ	 138
-ÐŠ	 137
-ÏÌÏ	 137
-ÒÕ	 136
-ÁÄ	 136
-_ÝÏ_	 136
-ÍÉ	 135
-ÃŠ	 135
-_î	 134
-_ÍÏ	 133
-ÁË	 133
-ËÉ_	 133
-ÏÀ	 132
-ÎÕ	 131
-ÉÍ	 130
-ŠÔ	 129
-_ËÁ	 129
-ÂÁ	 129
-_ÔÏ	 129
-§_	 128
-ÍÅ	 128
-ÐÅ	 128
-ÍŠ	 128
-_ÂÕ	 127
-×Ó	 126
-á_	 126
-Ï×Š	 123
-ÏË	 123
-×Å	 122
-ËŠ	 121
-:	 119
-_Ã	 118
-Õ×	 118
-ÂÉ	 116
-ÓŠ	 116
-ÇÁ	 115
-Ï§	 115
-ÐÁ	 115
-ÎÏ_	 115
-ÏÍÕ	 114
-ÍÕ_	 113
-_Ö	 113
-ÏÒÏ	 113
-ÏÔ	 113
-ÉÔØ	 112
-ÏÚ	 112
-?	 111
-ÔÕ	 110
-ÓÔÏ	 109
-_ú	 109
-ÏÞ	 109
-ÉÈ	 109
-ÕÔ	 109
-ÏÀ_	 108
-ŠË	 108
-_È	 106
-â	 106
-ÄÏ_	 106
-ŠÊ	 106
-_×ŠÄ	 106
-Ó×	 106
-ÚÎ	 105
-ÂŠ	 105
-ÐÒÉ	 105
-ÓÔÁ	 104
-ÁÚ	 104
-ËÒ	 104
-ËÁÖ	 104
-ÎÑ	 103
-ÕÄ	 103
-_ô	 102
-_ÇÏ	 102
-Ä_	 102
-ÔÏ_	 102
-ÉÔÉ	 102
-_ó	 101
-_ÔÁ	 101
-ÌÏ×	 101
-ì	 100
-_ÒÏ	 100
-ÞÁ	 99
-ÏÍÕ_	 99
-ÐÅÒ	 99
-_ÄÏ_	 98
-ÏÄÉ	 98
-ŠÓ	 98
-ÁÖÅ	 97
-ÌÁ_	 97
-ÁÊ	 96
-ÓÏ	 94
-ÁÔÉ_	 94
-_Õ	 94
-ÌÀ	 93
-!	 93
-_Ó×	 93
-..	 93
-ÅÒÅ	 92
-ÓË	 92
-ŠÌØ	 92
-ÓÉ	 92
-_ÐÒÉ	 91
-ÅÌ	 91
-ÐÒÏ	 91
-_ËÁÖ	 91
-ÈÏ	 91
-ÏÖ	 89
-þ	 89
-Ô_	 88
-ÉÔØ_	 88
-ÅÓ	 88
-ÞÏ	 86
-ÂÏ	 86
-ÓÌ	 86
-ËÁÖÅ	 86
-ÑÔ	 85
-ñ_	 85
-ÓÐ	 84
-ÔÏÒ	 84
-ÏÌÉ	 84
-_ËÁÖÅ	 83
-_ÐŠ	 83
-_ÍÁ	 82
-ÕÌ	 82
-ÕË	 82
-ç	 81
-õ	 81
-_ë	 81
-Á×_	 81
-ÎÎ	 81
-ÞÅ	 81
-ÍÅÎ	 81
-ÍÉ_	 80
-_Ê	 79
-_í	 79
-ØÓ	 78
-ÎË	 78
-ÁÀ	 78
-ÂÅ	 78
-ÃÅ	 78
-_ÐÒÏ	 77
-ŠÎ_	 77
-ÏÍ_	 77
-ÕÓ	 77
-ÅÍ	 77
-_ñ	 77
-_ä	 77
-_×Ï	 76
-_ÍÅ	 76
-ÉÈ_	 76
-ÅÔ	 76
-ØÏ	 75
-ÉÞ	 75
-ØËÉ	 75
-ÕÒ	 74
-ØÓÑ	 74
-ÔØÓ	 74
-ÔØÓÑ	 74
-Ï§_	 73
-_ÓÔÏ	 73
-ËÏÌ	 72
-".	 72
-."	 72
-ÏÌÏ×	 72
-ÊÏ	 72
-Ä×	 71
-Š×_	 71
-ÏÐ	 71
-Æ	 71
-_ÐÅ	 71
-Õ×Á	 71
-ÎÉÊ	 71
-ÓØ_	 70
-_â	 70
-ÌØË	 70
-_ÏÄ	 69
-ÅÎŠ	 69
-ÁÞ	 68
-ÁÌÉ	 68
-ŠÌØË	 68
-ÈÁ	 68
-ÑË_	 68
-ÔØÓÑ_	 68
-ÔÁË	 68