Index: trunk/gsdl/macros/english.dm
===================================================================
--- trunk/gsdl/macros/english.dm	(revision 1920)
+++ trunk/gsdl/macros/english.dm	(revision 1921)
@@ -532,5 +532,8 @@
 _textsome_ {_If_(_cgiargb_,ranked,some)}
 _textall_ {_If_(_cgiargb_,boolean,all)}
+_textformsome_ {_If_(_cgiargb_,ranked,some)}
+_textformall_ {_If_(_cgiargb_,natural,all)}
 _texticonqueryresultsbar_ {}
+_texticonsearchhistorybar_ {search history}
 _textfreqmsg1_ {Word count: }
 _textpostprocess_ {_If_(_quotedquery_,<br><i>post-processed to find _quotedquery_</i>
@@ -544,13 +547,35 @@
 _textmatches_ {Matches }
 _textbeginsearch_ {Begin Search}
-
-# _hselection_, _jselection_ and _nselection_ are set from within the server
-# some or all of them may remain unset
-
-_textsimplesearch_ {Search for _If_(_hselection_, _hselection_ )_If_(_jselection_,_textjselect_)_If_(_gselection_, at _gselection_ level)_If_(_nselection_, in _nselection_ language)
+_textrunquery_{Run Query}
+_textclearform_{Clear Form}
+
+#these go together in form search:
+#"Word or phrase  (fold, stem)  ... in field"
+_textwordphrase_{Word or phrase}
+_textinfield_{... in field}
+_textfoldstem_{(fold, stem)}
+
+_textadvquery_{Or enter a query directly:}
+_textallfields_{All fields}
+_textand_{and}
+_textor_{or}
+_textandnot_{and not}
+
+# _hselection_, _jselection_, _nselection_ and _gselection_ are set from 
+# within the server some or all of them may remain unset
+
+
+_textsimplesearch_ {Search for _If_(_hselection_, _hselection_) _If_(_jselection_, _textjselect_) _If_(_gselection_, at _gselection_ level) _If_(_nselection_, in _nselection_ language)
 which contain _querytypeselection_ of the words}
 
-_textadvancedsearch_ {Search _If_(_hselection_, _hselection_, _defaultindextext_)_If_(_jselection_,_textjselect_)_If_(_gselection_, at _gselection_ level)_If_(_nselection_, in _nselection_ language) 
+_textadvancedsearch_ {Search _If_(_hselection_, _hselection_, _defaultindextext_) _If_(_jselection_,_textjselect_) _If_(_gselection_, at _gselection_ level)_If_(_nselection_, in _nselection_ language) 
 using _querytypeselection_ query}
+
+_textformsimplesearch_ {Search for _If_(_hselection_, _hselection_) _If_(_jselection_, _textjselect_) _If_(_gselection_, at _gselection_ level) _If_(_nselection_, in _nselection_ language)
+which contain _formquerytypeselection_ of}
+
+_textformadvancedsearch_ {Search _If_(_hselection_, _hselection_, _defaultindextext_) _If_(_jselection_,_textjselect_) _If_(_gselection_, at _gselection_ level)_If_(_nselection_, in _nselection_ language) 
+and display results in _formquerytypeselection_ order}
+
 
 _textjselect_ {_If_(_hselection_, of) _jselection_}
@@ -563,15 +588,20 @@
 _textexplaineras_{C.E. and B.C.E are alternatives for A.D. and B.C. repsectively.  These terms are considered to be culture indiscriminate, and stand for "Common Era" and "Before the Common Era"} 
 
-
 _textstemon_ { (ignoring word endings)}
-_textclearhistory_ {Clear History}
-_textexpand_ {Expand}
-_textcontract_ {Contract}
+
 _textsearchhistory_ {Search History}
-_textquery_ {Query}
-_textresults_ {Results}
-_textview_ {View}
+
+#text macros for search history
 _textnohistory_ {Search history not available}
-
+_texthresult_ {result}
+_texthresults_ {results}
+_texthallwords_ {all words}
+_texthsomewords_ {some words}
+_texthboolean_ {boolean}
+_texthranked_ {ranked}
+_texthcaseon_ {case must match}
+_texthcaseoff_ {casefolded}
+_texthstemon_ {stemmed}
+_texthstemoff_ {unstemmed}
 
 #------------------------------------------------------------
@@ -589,4 +619,9 @@
 _heightqryresb_ {17}
 
+## "history" ## green_bar_left_aligned ## srchhistb ##
+_httpiconsrchhistb_ {_httpimg_/srchhistb.gif}
+_widthsrchhistb_ {_pagewidth_}
+_heightsrchhistb_ {17}
+
 ## "display" ## hand_made ##
 _httpicondisplay_ {_httpimg_/display.gif}
@@ -595,5 +630,4 @@
 
 
-
 ######################################################################
 # 'preferences' page
@@ -610,17 +644,20 @@
 _textpresentationprefs_ {Presentation preferences}
 _textpreferences_ {Preferences}
+_textcasediffs_ {Case differences:}
 _textignorecase_ { ignore case differences}
 _textmatchcase_ { upper/lower case must match}
+_textwordends_{Word endings:}
 _textstem_ { ignore word endings}
 _textnostem_ { whole word must match}
 _textprefop_ {Return up to _maxdocoption_ hits with _hitsperpageoption_ hits per page.}
-_textextlink_ {Access to external Web pages: }
+_textextlink_ {Access to external Web pages:}
 _textintlink_ {Source documents retrieved from:}
-_textlanguage_ {Interface language: }
-_textencoding_ {Encoding: }
-_textformat_ {Interface format: }
+_textlanguage_ {Interface language:}
+_textencoding_ {Encoding:}
+_textformat_ {Interface format:}
 _textall_ {all}
-_textsimplemode_ {simple query mode}
-_textadvancedmode_ {advanced query mode (allows boolean searching using !, &, |, and parentheses)}
+_textquerymode_{Query mode:}
+_textsimplemode_ { simple query mode}
+_textadvancedmode_ { advanced query mode (allows boolean searching using !, &, |, and parentheses)}
 _textlinkinterm_ {through intermediate page}
 _textlinkdirect_ {go directly there}
@@ -632,7 +669,23 @@
 Subcollections to include:
 <br>}
-_textfcoption_ {Include navigation bar at top of document pages}
-_texthloption_ {Highlight search terms within document text}
-_texthistorydisplay_ {display search history}
+_textfcoption_ { Include navigation bar at top of document pages}
+_texthloption_ { Highlight search terms within document text}
+_textsearchhistory_{Search history:}
+_texthistorydisplay_ { display _historynumrecords_search history records}
+_textnohistorydisplay_{ do not display search history}
+
+_texttypesearch_ {Type of search:}
+_texttextsearch_ {text search}
+_textformsearch_ {form search}
+_textqueryboxsize_ {Query box size:}
+_textregbox_{ regular query box}
+_textbigbox_{ large query box}
+_textformtype_ {Form type:}
+_textsimple_{ simple}
+_textadvanced_ { advanced}
+
+# used in "with 4 fields" in the form search box
+_textwith_{with}
+_textfields_{fields}
 
 
@@ -645,33 +698,4 @@
 _widthhpref_ {200}
 _heighthpref_ {57}
-
-
-
-######################################################################
-# 'delete search history' page
-package delhistory
-######################################################################
-
-
-#------------------------------------------------------------
-# text macros
-#------------------------------------------------------------
-
-_textdsh_ {Delete Search History}
-
-_textselectdelete_ {<a href="_httpclearhistory_&hdh=1">Delete all
-records</a> or select records to <select name=hmode><option value=save>not
-delete<option value=delete selected>delete</select><br> Records can be
-selected by typing their numbers into the box,<br> or by clicking in the
-boxes in each record.<br> Acceptable values are 1,2,3-6,7- etc }
-
-_textclearselected_ {Clear selected}
-_textselect_ {select}
-
-
-#------------------------------------------------------------
-# icons
-#------------------------------------------------------------
-
 
 
@@ -992,5 +1016,5 @@
 <h3>How to use this feature:</h3>
 <ul>
-   <li>To search for documents about a sinlge year:<p>
+   <li>To search for documents about a single year:<p>
    <ul>
        <li>Type in any ordinary search terms as you normally would.	
@@ -1001,5 +1025,5 @@
        <li>Begin your search as you ordinarily would.
    </ul>
-<p><li>To search for documents abou a time period or range of years:<p>
+<p><li>To search for documents about a time period or range of years:<p>
    <ul>
        <li>Type in any ordinary search terms as you normally would.