Index: unk/gsdl/packages/Makefile
===================================================================
--- /trunk/gsdl/packages/Makefile	(revision 1935)
+++ 	(revision )
@@ -1,56 +1,0 @@
-###########################################################################
-#
-# Makefile -- Makefile for packages included with Greenstone
-#
-# A component of the Greenstone digital library software
-# from the New Zealand Digital Library Project at the
-# University of Waikato, New Zealand.
-#
-# Copyright (C) 2000 New Zealand Digital Library Project
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
-#
-###########################################################################
-
-
-# PACKAGEDIRS contains the packages that we want to make and install.  It
-# is assumed that each package will have at least four rules: all, install,
-# clean, and distclean.
-
-PACKAGEDIRS = unix/wv/wv-0.6.0-gs  wget/wget-1.5.3  yaz
-
-all:
-	for odir in $(PACKAGEDIRS); do \
-          echo making $@ in $$odir; \
-          (cd $$odir && $(MAKE) $(MDEFINES) $@) || exit 1; \
-        done
-
-install:
-	for idir in $(PACKAGEDIRS); do \
-          echo installing $$idir; \
-          (cd $$idir && $(MAKE) install) || exit 1; \
-        done
-
-clean:
-	for subdir in $(PACKAGEDIRS); do \
-          echo cleaning $@ in $$subdir; \
-          (cd $$subdir && $(MAKE) clean) || exit 1; \
-        done
-
-distclean:
-	for subdir in $(PACKAGEDIRS); do \
-          echo cleaning $@ in $$subdir; \
-          (cd $$subdir && if test -e Makefile; then $(MAKE) distclean;fi) || exit 1; \
-        done
Index: /trunk/gsdl/packages/Makefile.in
===================================================================
--- /trunk/gsdl/packages/Makefile.in	(revision 1936)
+++ /trunk/gsdl/packages/Makefile.in	(revision 1936)
@@ -0,0 +1,62 @@
+###########################################################################
+#
+# Makefile -- Makefile for packages included with Greenstone
+#
+# A component of the Greenstone digital library software
+# from the New Zealand Digital Library Project at the
+# University of Waikato, New Zealand.
+#
+# Copyright (C) 2000 New Zealand Digital Library Project
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+#
+###########################################################################
+
+
+# PACKAGEDIRS contains the packages that we want to make and install.  It
+# is assumed that each package will have at least four rules: all, install,
+# clean, and distclean.
+USE_Z3950=@USE_Z3950@
+ifeq ($(USE_Z3950, 1)
+YAZ=yaz
+else
+YAZ=
+endif
+
+PACKAGEDIRS = unix/wv/wv-0.6.0-gs  wget/wget-1.5.3  $(YAZ)
+
+all:
+	for odir in $(PACKAGEDIRS); do \
+          echo making $@ in $$odir; \
+          (cd $$odir && $(MAKE) $(MDEFINES) $@) || exit 1; \
+        done
+
+install:
+	for idir in $(PACKAGEDIRS); do \
+          echo installing $$idir; \
+          (cd $$idir && $(MAKE) install) || exit 1; \
+        done
+
+clean:
+	for subdir in $(PACKAGEDIRS); do \
+          echo cleaning $@ in $$subdir; \
+          (cd $$subdir && $(MAKE) clean) || exit 1; \
+        done
+
+distclean:
+	for subdir in $(PACKAGEDIRS); do \
+          echo cleaning $@ in $$subdir; \
+          (cd $$subdir && if test -e Makefile; then $(MAKE) distclean;fi) || exit 1; \
+        done