Index: /trunk/gsdl/macros/english2.dm
===================================================================
--- /trunk/gsdl/macros/english2.dm	(revision 1956)
+++ /trunk/gsdl/macros/english2.dm	(revision 1957)
@@ -24,31 +24,4 @@
 
 _textpagetitle_ {Greenstone Digital Library}
-_textfb_ {Feedback}
-_textinfosheet_ {Info Sheet}
-
-_textprojhead_ {The Greenstone software and <br>The New Zealand Digital Library Project}
-_textprojinfo_ {
-<p>
-The Greenstone Digital Library software provides a new way of
-organizing information and making it available over the Internet or on
-CD-ROM. It is open-source software, available under the terms of the
-GNU General Public License. 
-<p>
-A digital library is made up of a set of collections. Each collection of
-information comprises several (typically several thousand, or even
-several million) documents, which share a uniform searching and
-browsing interface. Collections can be organized in many different
-ways while retaining a strong family resemblance. 
-<p>
-The 
-<a href="http://www.nzdl.org">New Zealand Digital Library Project</a>
-is a research programme at The University of Waikato whose aim is to 
-develop the underlying technology for digital libraries and make it 
-available publicly so that others can use it to create their own 
-collections.
-Greenstone was created to further this objective.
-Further details are available from  
-<a href="http://www.nzdl.org">http://www.nzdl.org</a>
-}
 
 _textpoem_ {
@@ -65,14 +38,17 @@
 
 _textgreenstone_ { 
-<p>Greenstone is a semi-precious stone that (like this software) is sourced in New Zealand.  In traditional Maori society it was the most highly prized and sought after of all substances.  It can absorb and hold <i>wairua</i>, which is a spirit or life force, and is endowed with traditional virtues that make it an appropriate emblem for a
-public-domain digital library project.  Its lustre shows charity; its
-translucence, honesty; its toughness, courage; and the sharp edge it can
-take, justice.  The carved piece used in the Greenstone Digital Library
-Software logo is a <i>patu</i> or fighting club, and is a family heirloom
-of one of our project members.  In hand-to-hand combat its delivery is very
-quick, very accurate, and very complete.  We like to think these qualities
-also apply to our software, the razor sharp edge of the <i>patu</i>
-symbolizing the leading edge of technology.
-
+<p>Greenstone is a semi-precious stone that (like this software) is sourced
+in New Zealand.  In traditional Maori society it was the most highly prized
+and sought after of all substances.  It can absorb and hold <i>wairua</i>,
+which is a spirit or life force, and is endowed with traditional virtues
+that make it an appropriate emblem for a public-domain digital library
+project.  Its lustre shows charity; its translucence, honesty; its
+toughness, courage; and the sharp edge it can take, justice.  The carved
+piece used in the Greenstone Digital Library Software logo is a <i>patu</i>
+or fighting club, and is a family heirloom of one of our project members.
+In hand-to-hand combat its delivery is very quick, very accurate, and very
+complete.  We like to think these qualities also apply to our software, the
+razor sharp edge of the <i>patu</i> symbolizing the leading edge of
+technology.
 }
 
Index: /trunk/gsdl/macros/gsdl.dm
===================================================================
--- /trunk/gsdl/macros/gsdl.dm	(revision 1956)
+++ /trunk/gsdl/macros/gsdl.dm	(revision 1957)
@@ -18,101 +18,145 @@
 #######################################################################
 
-_httpgsdlmanual_ {_httppublications_/gsdl_manual.pdf}
-
 _pagetitle_ {Greenstone Digital Library Software}
-
-_imagethispage_ {_imagegreenstone_}
+#_imagethispage_ {_imagegreenstone_}
 
 _content_ {
 _iconblankbar_
-<h2>Greenstone Digital Library Software</h2>
 
 <p>
-The Greenstone Digital Library software provides a new way of
-organizing information and making it available over the Internet or on
-CD-ROM. 
-<p>
-A digital library is made up of a set of collections. 
-Each collection of information comprises several 
-(typically several thousand, or even several million) documents, 
-which share a uniform searching and browsing interface. 
-Collections can be organized in many different ways while 
-retaining a strong family resemblance. 
-Numerous examples are hosted at the New Zealand Digital Library Project
-web site (<a href="http://www.nzdl.org">http://www.nzdl.org</a>).
-<p>
-Although primarily designed for access over the Web, 
-Greenstone collections can be made available,
-in precisely the same form, on CD-ROM for standalone PCs.  
-Greenstone CDs work with any version of Microsoft Windows.
-<p>
-Greenstone is open-source software, 
-available under the terms of the GNU General Public License. 
-The latest version can always be
-<a href="http://www.nzdl.org/html/DOWNLOAD.html">downloaded</a>
-from
-<a href="ftp://nzdl.org/pub/gsdl/">ftp://nzdl.org/pub/gsdl/</a>.
-Documentation is available in the form of 
-the Greenstone Digital Library Software manual.
-<p>
 
-<center><table><tr align=center valign=center>
-<td>_home:iconpdf_</td>
-<td><a href=_httpgsdlmanual_>Manual</a></td>
-<td width=10>&nbsp;</td>
-<td>_home:iconpdf_</td>
-<td><a href="_httppublications_/NZDLtext.pdf">_home:textinfosheet_</a></td>
-<td width=10>&nbsp;</td>
-<td>_home:iconpdf_</td>
-<td><a href="_httppublications_/NZDLpictures.pdf">Screenshots</a></td>
-</tr></table></center>
 
-<p>
-_iconblankbar_
-<p>
-<h2>Mailing list</h2>
-<p>
-There is now a mailing list for Greenstone, intended primarily for
-discussions about the digital library software developed by the New Zealand
-Digital Library project.  If you are, or plan to be, an active user of
-Greenstone, you should consider joining the mailing list and contributing
-to the discussions.
-<p>
-This mailing list is hosted by the Pathfinder Library System in beautiful
-Grand Junction, Colorado (John Campbell, john@colosys.net).  To subscribe,
-send email to <a
-href="mailto:majordomo@colosys.net">majordomo@colosys.net</a> with the text
-<blockquote>
-subscribe greenstone
-</blockquote>
-(no subject, no name, nothing else).  To send a message to the list,
-address it to <a
-href="mailto:greenstone@colosys.net">greenstone@colosys.net</a>.
+<table border=0 cellspacing=0 cellpadding=0>
+ <tr>
+  <td valign=top align=center>_imagegreenstone_</td>
+  <td valign=top>
+  Greenstone is a suite of software which has the ability to serve digital
+  library collections and build new collections.  It provides a new way of
+  organizing information and publishing it on the Internet or on CD-ROM.
+  Greenstone is produced by the New Zealand Digital Library Project at the
+  University of Waikato, and distributed in cooperation with UNESCO and the
+  Humanities Library Project. It is open-source software, available from
+  <i>http://nzdl.org</i> under the terms of the GNU General Public License.
+  <br><br>
+  </td>
+ </tr>
+ <tr>
+  <td valign=top align=center>
+  <h2><a href="http://nzdl.org">nzdl.org</a></h2>
+  </td>
+  <td valign=top>
+  The New Zealand Digital Library website (<a href="http://nzdl.org">http://nzdl.org</a>) contains
+  numerous example collections, all created with the Greenstone software, which
+  are publicly availabel for you to peruse. They exemplify various searching and
+  browsing options, and include collections in Arabic, Chinese, French, Maori,
+  and Spanish, as well as English. There are also some music
+  collections.
+  <br><br>
+  </td>
+ </tr>
+ <tr>
+  <td valign=top align=center>
+  <h2>platform</h2>
+  </td>
+  <td valign=top>
+  Greenstone runs on Windows and Unix. The distribution includes ready-to-use
+  binaries for all versions of Windows, and for Linux. It also includes complete
+  source code for the system, which can be compiled using Microsoft C++ or gcc
+  Greenstone works with associated software that is freely available: the Apache
+  Webserver and PERL. The user interface uses a Web browser: typically Netscape
+  Navigator or Internet Explorer.
+  <br><br>
+  </td>
+ </tr>
+ <tr>
+  <td valign=top align=center>
+    <a href="http://nzdl.org/hdl"><img border=0 width=101 height=100 src="_httpimg_/hdlimg.jpg"></a>
+  </td>
+  <td valign=top>
+  Many document collections are distributed on CD-ROM using the Greenstone
+  software. For example, the <i>Humanity Development Library</i> contains 1,230
+  publications ranging from accounting to water sanitation. It runs on minimal
+  computing facilities such as those typically found in developing countries. The
+  information can be accessed by searching, browsing by subject, browsing by
+  titles, browsing by organization, browsing a list of how-tos, and by randomly
+  viewing the book covers.
+  <br><br>
+  </td>
+ </tr>
+ <tr>
+  <td valign=top align=center>
+  <h2>customisation</h2>
+  </td>
+  <td valign=top>
+  Greenstone is specifically designed to be highly extensible and
+  customisable. New document and metadata formats are accommodated by writing
+  "plugins" (in Perl). Analogously, new metadata browsing structures can be
+  implemented by writing "classifiers." The user interface look-and-feel can be
+  altered using "macros" written in a simple macro language. A Corba protocol
+  allows agents (e.g. in Java) to use all the facilities associated with document
+  collections. Finally, the source code, in C++ and Perl, is available and
+  accessible for modification.
+  <br><br>
+  </td>
+ </tr>
+ <tr>
+  <td valign=top align=center>
+  <h2>documentation</h2>
+  </td>
+  <td valign=top>
+  There are three documents that explain the Greenstone system:
+<ul>
+<li> The Greenstone Digital Library Software Installer's Guide
+<li> The Greenstone Digital Library Software User's Guide
+<li> The Greenstone Digital Library Software Developer's Guide
+</ul><br>
+</tr>
+ <tr>
+  <td valign=top align=center>
+  <h2>mailing list</h2>
+  </td>
+  <td valign=top>
+  There is a mailing list intended primarily for discussions about the Greenstone
+  digital library software.  Active users of Greenstone should consider joining
+  the mailing list and contributing to the discussions.  The mailing list is
+  hosted by the Pathfinder Library System in beautiful Grand Junction, Colorado
+  (John Campbell, john@colosys.net). To subscribe, send email to <a
+  href="mailto:majordomo@colosys.net">majordomo@colosys.net</a> with the text
+  <ul>subscribe greenstone </ul> (no subject, no name, nothing else). To send a
+  message to the list, address it to <a
+  href="mailto:greenstone@colosys.net">greenstone@colosys.net</a>.
+  <br><br>
+ </tr>
+ <tr>
+  <td valign=top align=center>
+   <h2>bugs</h2>
+  </td>
+  <td valign=top>
+  We want to ensure that this software works well for you.  Please report any
+  bugs to <a href="mailto:majordomo@colosys.net">greenstone@cs.waikato.ac.nz</a>
+  <br><br>
+  </td>
+ </tr>
+ <tr>
+  <td valign=top align=center>
+   <h2>credits</h2>
+  </td>
+  <td valign=top>
+  The Greenstone software is a collaborative effort between many people. Rodger
+  McNab and Stefan Boddie are the principal architects and implementors.
+  Contributions have been made by David Bainbridge, George Buchanan, Hong Chen,
+  Elke Duncker, Carl Gutwin, Geoff Holmes, John McPherson, Craig Nevill-Manning,
+  Gordon Paynter, Bernhard Pfahringer, Todd Reed, Bill Rogers, and Stuart
+  Yeates. Other members of the New Zealand Digital Library project provided
+  advice and inspiration in the design of the system: Mark Apperley, Sally Jo
+  Cunningham, Steve Jones, Te Taka Keegan, Michel Loots, Malika Mahoui and Lloyd
+  Smith. We would also like to acknowledge all those who have contributed to the
+  GNU-licensed packages included in this distribution: MG, GDBM, WGET, WVWARE,
+  PDFTOHTML.
+  </td>
+ </tr>
+</table>
 
-<p>
-_iconblankbar_
-<p>
-<h2>Credits</h2>
-<p>
-Greenstone Digital Library Software is produced by the New Zealand Digital
-Library project.  The current software was designed and implemented by
-Rodger McNab, Stefan Boddie, Bill Rogers, Hong Chen and Stuart Inglis, and
-has benefited greatly from previous versions constructed by Craig
-Nevill-Manning and Todd Reed and previous interface designs by Che
-Tamahere.
-<p>
-The New Zealand Digital Library project is directed by Ian Witten and
-involves Mark Apperley, David Bainbridge, Sally Jo Cunningham, Steve Jones,
-Te Taka Keegan, Malika Mahoui and Lloyd Smith as principal investigators.
-Other researchers who have contributed to the project include Carl Gutwin,
-Rob Holte, Gordon Paynter and Bill Teahan.
-<p>
-Greenstone Digital Library Software uses the MG search engine produced
-principally by Alistair Moffat at the University of Melbourne and described
-in the book <i>Managing Gigabytes: Compressing and indexing documents and
-images</i> by Ian H. Witten, Alistair Moffat, and Tim C. Bell (Van Nostrand
-Reinhold, 1994).
-<p>
-_iconblankbar_
+<p>_iconblankbar_
 <p>
 <table>
Index: /trunk/gsdl/macros/home.dm
===================================================================
--- /trunk/gsdl/macros/home.dm	(revision 1956)
+++ /trunk/gsdl/macros/home.dm	(revision 1957)
@@ -16,9 +16,6 @@
 #######################################################################
 
-_iconnzdl_ {<img src="_httpiconnzdl_" width=_widthnzdl_ height=_heightnzdl_ alt="The New Zealand Digital Library">}
-_icongbull_ {<img src="_httpicongbull_">}
-_iconpdf_ {<img src="_httpiconpdf_">}
-_iconselectcollection_ {<img src="_httpiconselcolgr_" width=_widthselcolgr_ height=_heightselcolgr_ alt=_altselcolgr_>}
-_iconmusiclibrary_ {<img src="_httpicontmusic_" border=1 alt="meldex music library">}
+_iconselectcollection_ {<img align=texttop src="_httpiconselcolgr_" width=_widthselcolgr_ height=_heightselcolgr_ alt=_altselcolgr_>}
+_iconmusiclibrary_ {<img align=texttop src="_httpicontmusic_" border=1 alt="meldex music library">}
 
 #######################################################################
@@ -67,33 +64,7 @@
 <p>_iconblankbar_
 </center>)
-
-<p><center><h2>_textprojhead_</h2></center>
-
-<table border=0 cellpadding=5>
-<tr valign=top>
-<td>
-<table><tr valign=middle><td>_icongbull_</td><td><a href="mailto:_mailaddr_">_textfb_</a></td></tr></table>
-<table><tr valign=middle><td>_icongbull_</td><td><a href="http://www.nzdl.org">NZDL</a></td></tr></table>
-<table><tr valign=middle><td>_icongbull_</td><td><a href="_httppagex_(gsdl)">Greenstone</a></td></tr></table>
-<table><tr valign=middle><td>_iconpdf_</td><td><a href="_gsdl:httpgsdlmanual_">Manual</a></i></td></tr></table>
-<table><tr valign=middle><td>_iconpdf_</td><td><a href="_httppublications_/NZDLtext.pdf">_textinfosheet_</a></td></tr></table>
-</td>
-<td>_textprojinfo_</td>
-</tr></table>
-
-<p>_iconblankbar_
-<table>
-<tr valign=top>
-<td>_textpoem_</td>
-<td>_imagegreenstone_</td>
-</tr></table>
-<p>_textgreenstone_
-<p>_iconblankbar_
-<p>Greenstone software by <a href="http://www.nzdl.org">The New Zealand Digital Library Project</a>,
-<br><a href="http://www.cs.waikato.ac.nz/cs">Department of Computer Science</a>, 
-<a href="http://www.waikato.ac.nz">University of Waikato</a>, 
-New Zealand
+<h3><a href="_httppagex_(gsdl)">About the Greenstone software</a></h3>
+<center>_iconblankbar_</center>
 }
-
 
 # the _textgocollector_ and _textgoadmin_ macros may be overridden
@@ -101,6 +72,6 @@
 # facilities are disabled
 _textgocollector_ {
-<tr valign=middle>
-<td>_imagecollector_</td>
+<tr valign=top>
+<td valign=top>_imagecollector_</td>
 <td>Helps you create new collections, modify or add to existing ones, or
 delete collections</td>
@@ -109,6 +80,6 @@
 
 _textgoadmin_ {
-<tr valign=middle>
-<td>_imageadmin_</td>
+<tr valign=top>
+<td valign=top>_imageadmin_</td>
 <td>Allows you to add new users, summarizes the collections in the system,
 gives technical information on the Greenstone installation</td>